> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/servoy-developer/object-editors/scripting-editor/refactoring.md).

# Refactoring

## Overview

Servoy comes with support for Refactoring. Code refactoring for a selected item can be accessed by selecting [Refactor](/reference/servoy-developer/object-editors/scripting-editor/getting-started.md#refactor) from the Script Editor context menu.

It is important to note that for refactoring to work comprehensively, the code must be properly documented through JSDoc. Insufficient information will result in decreased usefulness of the refactoring functionality.

## Refactoring functions

The available Refactoring functions are described below:

### Rename

keybinding: `Alt+Shift+R`\
Opens a window where the user can insert a new name.\
Renames variables (global, form and local (within functions)), functions and function parameters. The rename refactor changes the name both for the declaration of the object to be renamed, as well as all references to the object.

### Move

Opens the [Move](/reference/servoy-developer/object-editors/refactor-move-wizard.md) wizard.

### Extract Local Variable

keybinding: `Alt+Shift+L`\
Extracts the selected value within a function's source to a local variable (i.e., a variable inside a function declaration). All occurrences of the selected value within the function's source are replaced by a reference to the new variable.

### Change Method Signature

keybinding: `Alt+Shift+C` Alters the signature of an existing method and updates all calls to the method to use the new signature. Newly introduced parameters can be given a default value, so all calls to the method can call the method with the default value for the new parameter.

### Extract Method

keybinding: `Alt+Shift+M`\
Creates a new function based on the selected code within a function's source and replaces the selected code with a call to the newly created function.

### Introduce Parameter

Takes a hard-coded value inside the source of a function and creates a new parameter for it, replacing the hard-coded value with the parameter and updating all calls to the method to send the previously hard-coded value as value for the newly created parameter.

### Inline

keybinding: `Alt+Shift+I`\
Replaces a method call with the code of the called method.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.servoy.com/reference/servoy-developer/object-editors/scripting-editor/refactoring.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
